/*
 * Manager.cpp
 *
 *  Created on: 28.01.2016
 *      Author: jedi
 */
#include <iostream>
#include <regex>
#include <string>

#include "Manager.h"

using namespace std;

Manager::Manager(string file) :
        db(file) {
    db.query
            << "CREATE TABLE IF NOT EXISTS passwd (type varchar(20),user varchar(255),host varchar(255),passwd varchar(512));"
            << flush;
}

Manager::~Manager() {
    db.close();
}

int Manager::add(string pattern, string passwd) {
    std::cmatch sm;
    if (regex_match(pattern.c_str(), sm,
            std::regex(
                    "^([a-zA-Z0-9]+):([a-zA-Z0-9/_\\.\\-]+)@([a-zA-Z0-9\\.\\-]+)$"))) {
        db.query << "INSERT INTO passwd (type, user, host, passwd) VALUES('"
                << sm[1] << "', '" << sm[2] << "','" << sm[3] << "','" << passwd
                << "');" << flush;
    } else if (regex_match(pattern.c_str(), sm,
            std::regex("^([a-zA-Z0-9]+):([a-zA-Z0-9/_\\.\\-]+)$"))) {
        db.query << "INSERT INTO passwd (type, user, host, passwd) VALUES('"
                << sm[1] << "', '" << sm[2] << "','" << sm[2] << "','" << passwd
                << "');" << flush;
    } else {
        cerr << "invalid pattern: " << pattern << endl;
    }
    return 0;
}

int Manager::create(string pattern) {
    cout << "12345" << endl;
    db.query
            << "INSERT INTO passwd (type, user, host, passwd) VALUES('http', 'fish','test.de','12345');"
            << flush;
    return 0;
}

int Manager::show() {
    db.query << "SELECT type, user, host, passwd FROM passwd;" << flush;
    for (vector<string> row : db.result) {
        cout << row.at(0) << ":" << row.at(1) << "@" << row.at(2) << "\t"
                << row.at(3) << endl;
    }
    return 0;
}

int Manager::clear() {
    db.query << "DELETE FROM passwd;" << flush;
    return 0;
}

int Manager::get(string pattern) {
    db.query
            << "SELECT type, user, host, passwd FROM passwd WHERE type='http' AND user='blub';"
            << flush;
    for (vector<string> row : db.result) {
        cout << row.at(0) << "://" << row.at(1) << "@" << row.at(2) << "\t"
                << row.at(3) << endl;
    }
    return 0;
}

